Index: /trunk/kernel/libk/bits.c
===================================================================
--- /trunk/kernel/libk/bits.c	(revision 656)
+++ /trunk/kernel/libk/bits.c	(revision 657)
@@ -1,7 +1,7 @@
 /*
- * bits.c - bits manipulation functions implementation
+ * bits.c - bitmap API implementation
  *
  * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
- *         Alain Greiner    (2016,2017,2018,2019)
+ *         Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,4 +26,8 @@
 #include <bits.h>
 
+//////////////////////////////////////////////////////////////////////////////
+//////////////     local access functions     ///////////////////////////////
+//////////////////////////////////////////////////////////////////////////////
+
 ////////////////////////////////////
 void bitmap_init( bitmap_t * bitmap,
@@ -42,6 +46,6 @@
                         uint32_t   index )
 {
-	uint32_t  word = index / 32;
-	uint32_t  bit  = index % 32;
+	uint32_t  word = index >> 5;
+	uint32_t  bit  = index & 0x1F;
 
 	bitmap[word] |= ( 1 << bit );
@@ -52,6 +56,6 @@
                           uint32_t   index )
 {
-	uint32_t  word = index / 32;
-	uint32_t  bit  = index % 32;
+	uint32_t  word = index >> 5;
+	uint32_t  bit  = index & 0x1F;
 
 	bitmap[word] &= ~( 1 << bit );
@@ -62,9 +66,44 @@
                             uint32_t   index )
 {
-	uint32_t  word = index / 32;
-	uint32_t  bit  = index % 32;
+	uint32_t  word = index >> 5;
+	uint32_t  bit  = index & 0x1F;
 
 	return (bitmap[word] & ( 1 << bit )) != 0;
 }
+
+/////////////////////////////////////////
+uint32_t bitmap_alloc( bitmap_t * bitmap,
+                       uint32_t   size )
+{
+    uint32_t max_word;
+    uint32_t max_bit; 
+	uint32_t word;
+	uint32_t bit;
+ 
+    if( size )
+    {
+        max_word = ( (size-1) >>5 ) + 1;
+
+        for( word = 0 ; word < max_word ; word++ )
+	    {
+            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
+
+		    if(bitmap[word] != 0XFFFFFFFF)
+		    {
+			    for(bit = 0 ; bit < max_bit ; bit++)
+			    {
+				    if( (bitmap[word] & (1 << bit)) == 0 )
+                    {
+                        bitmap[word] |= (1 << bit);
+                        return (word*32 + bit);
+                    }
+			    }
+            }
+		}
+	}
+
+	return -1;
+
+}  // end bitmap_alloc()
 
 //////////////////////////////////////////
@@ -207,4 +246,5 @@
 {
     uint32_t max_word;
+    uint32_t max_bit;
 	uint32_t word;
 	uint32_t bit;
@@ -216,7 +256,9 @@
         for( word = 0 ; word < max_word ; word++ )
 	    {
+            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
+
 		    if(bitmap[word] != 0)
 		    {
-			    for(bit = 0 ; bit < 32 ; bit++)
+			    for(bit = 0 ; bit < max_bit ; bit++)
 			    {
 				    if( bitmap[word] & (1 << bit) ) return (word*32 + bit);
@@ -235,4 +277,5 @@
 {
     uint32_t max_word;
+    uint32_t max_bit;
 	uint32_t word;
 	uint32_t bit;
@@ -244,7 +287,9 @@
         for( word = 0 ; word < max_word ; word++ )
 	    {
+            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
+
 		    if(bitmap[word] != 0XFFFFFFFF)
 		    {
-			    for(bit = 0 ; bit < 32 ; bit++)
+			    for(bit = 0 ; bit < max_bit ; bit++)
 			    {
 				    if( (bitmap[word] & (1 << bit)) == 0 ) return (word*32 + bit);
@@ -258,2 +303,131 @@
 }  // bitmap_ffc()
 
+
+//////////////////////////////////////////////////////////////////////////////
+//////////////     remote access functions     ///////////////////////////////
+//////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////
+void bitmap_remote_init( xptr_t   bitmap_xp,
+                         uint32_t len )
+{
+    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
+    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
+
+    uint32_t word;
+    uint32_t nwords = BITMAP_SIZE( len );
+
+    for( word = 0 ; word < nwords ; word++ )
+    {
+        hal_remote_s32( XPTR( bitmap_cxy , &bitmap_ptr[word] ) , 0 );
+    }
+}
+
+////////////////////////////////////////////////////
+inline void bitmap_remote_set( xptr_t     bitmap_xp,
+                               uint32_t   index )
+{
+    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
+    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
+
+	uint32_t  word = index / 32;
+	uint32_t  bit  = index % 32;
+
+    hal_remote_atomic_or( XPTR( bitmap_cxy , &bitmap_ptr[word] ) , (1 <<bit) );
+}
+
+//////////////////////////////////////////////////////
+inline void bitmap_remote_clear( xptr_t     bitmap_xp, 
+                                 uint32_t   index )
+{
+    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
+    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
+
+	uint32_t  word = index / 32;
+	uint32_t  bit  = index % 32;
+
+    hal_remote_atomic_and( XPTR( bitmap_cxy , &bitmap_ptr[word] ) , ~(1 <<bit) );
+}
+
+///////////////////////////////////////////////////
+uint32_t bitmap_remote_alloc( xptr_t     bitmap_xp,
+                              uint32_t   size )
+{
+    uint32_t max_word;
+    uint32_t max_bit; 
+	uint32_t word;
+	uint32_t bit;
+    xptr_t   word_xp;
+    uint32_t value;
+ 
+    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
+    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
+
+    if( size )
+    {
+        max_word = ( (size-1) >>5 ) + 1;
+
+        for( word = 0 ; word < max_word ; word++ )
+	    {
+            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
+
+            word_xp = XPTR( bitmap_cxy , &bitmap_ptr[word] );
+
+            value   = hal_remote_l32( word_xp );
+
+		    if( value != 0XFFFFFFFF )
+		    {
+			    for(bit = 0 ; bit < max_bit ; bit++)
+			    {
+				    if( (value & (1 << bit)) == 0 )
+                    {
+                        hal_remote_s32( word_xp , value | (1 << bit) );
+                        return (word*32 + bit);
+                    }
+			    }
+            }
+		}
+	}
+
+	return -1;
+
+}  // end bitmap_alloc()
+
+///////////////////////////////////////////////
+uint32_t bitmap_remote_ffc( xptr_t   bitmap_xp, 
+                                     uint32_t size )
+{
+    uint32_t max_word;
+    uint32_t max_bit;
+	uint32_t word;
+	uint32_t bit;
+    uint32_t value;
+ 
+    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
+    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
+
+    if( size )
+    {
+        max_word = ( (size-1) >>5 ) + 1;
+
+        for( word = 0 ; word < max_word ; word++ )
+	    {
+            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
+
+            value = hal_remote_l32( XPTR( bitmap_cxy , &bitmap_ptr[word] ) );
+
+		    if( value != 0xFFFFFFFF )
+		    {
+			    for(bit = 0 ; bit < max_bit ; bit++)
+			    {
+				    if( (value & (1 << bit)) == 0 ) return (word*32 + bit);
+			    }
+            }
+		}
+	}
+
+	return -1;
+
+}  // bitmap_remote_ffc()
+
+
Index: /trunk/kernel/libk/bits.h
===================================================================
--- /trunk/kernel/libk/bits.h	(revision 656)
+++ /trunk/kernel/libk/bits.h	(revision 657)
@@ -1,7 +1,7 @@
 /*
- * bits.h - bits manipulation helper functions
+ * bits.h - bitmap API definition
  *
  * Author   Ghassan Almaless (2008,2009,2010,2011,2012)
- *          Alain Greiner    (2016,2017,2018,2019)
+ *          Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -28,15 +28,21 @@
 #include <kernel_config.h>
 #include <hal_kernel_types.h>
-
-/*********************************************************************************************
- * These macros are NOT used by the bitmap, but can be useful in other contexts... [AG]
- *********************************************************************************************/
-
-#define ARROUND_UP(val, size) (((val) & ((size) -1)) ? ((val) & ~((size)-1)) + (size) : (val))
-#define ARROUND_DOWN(val, size)  ((val) & ~((size) - 1))
-
-#define ABS(x) (((x) < 0) ? -(x) : (x))
-#define MIN(x,y) (((x) < (y)) ? (x) : (y))
-#define MAX(x,y) (((x) < (y)) ? (y) : (x))
+#include <hal_remote.h>
+
+/**********************************************************************************************
+ * This file defines the API to access a generic bitmap, that can be local or remote.
+ * It is implemented as an array of uint32_t words.
+ * The number of entries in this array is statically defined at compile time
+ * and defines the max number of items that can be registered in the bitmap.
+ * The remote accesses are used in the VFS by the inum allocator.
+ *********************************************************************************************/
+
+typedef uint32_t    bitmap_t;
+
+/**********************************************************************************************
+ * This macro returns the number of 32 bits words required to register <size> entries.
+ *********************************************************************************************/
+
+#define BITMAP_SIZE(size) ( ((size) & 31) ? (((size)>>5) + 1) : ((size)>>5) )
 
 /**********************************************************************************************
@@ -44,4 +50,5 @@
  * It returns 0xFFFFFFFF if data is larger than 0x80000000.
  *********************************************************************************************/
+
 #define POW2_ROUNDUP(data) ( (data <= 0x00000001) ? 0x00000001  : \
                              (data <= 0x00000002) ? 0x00000002  : \
@@ -77,23 +84,29 @@
                              (data <= 0x80000000) ? 0x80000000  : 0xFFFFFFFF )
 
-/**********************************************************************************************
- * This macro returns the number of 32 bits words required to register <size> entries.
- *********************************************************************************************/
-
-#define BITMAP_SIZE(size) ( ((size) & 31) ? (((size)>>5) + 1) : ((size)>>5) )
-
-typedef uint32_t    bitmap_t;
-
-/*********************************************************************************************
- * This function reset all bits in a bitmap. (array ot 32 bits words).
+/*********************************************************************************************
+ * These macros are NOT used by the bitmap, but are useful in other contexts... [AG]
+ *********************************************************************************************/
+
+#define ARROUND_UP(val, size) (((val) & ((size) -1)) ? ((val) & ~((size)-1)) + (size) : (val))
+#define ARROUND_DOWN(val, size)  ((val) & ~((size) - 1))
+
+#define ABS(x) (((x) < 0) ? -(x) : (x))
+#define MIN(x,y) (((x) < (y)) ? (x) : (y))
+#define MAX(x,y) (((x) < (y)) ? (y) : (x))
+
+/*********************************************************************************************
+ * This function reset all bits in a local or remote bitmap. 
  *********************************************************************************************
  * @ bitmap  : pointer on first word in the bitmap.
- * @ len     : number of bits to reset. 
- ********************************************************************************************/
-void bitmap_init( bitmap_t * bitmap,
-                  uint32_t   len );
-
-/*********************************************************************************************
- * This function set a specific bit in a bitmap.
+ * @ size    : number of bits in bitmap. 
+ ********************************************************************************************/
+extern void bitmap_init( bitmap_t * bitmap,
+                         uint32_t   size );
+
+extern void bitmap_remote_init( xptr_t   bitmap_xp,
+                                uint32_t size );
+
+/*********************************************************************************************
+ * These functions set a specific bit in a local or remote bitmap.
  *********************************************************************************************
  * @ bitmap  : pointer on the bitmap
@@ -103,6 +116,9 @@
                                uint32_t   index );
 
-/*********************************************************************************************
- * This function clear a specific bit in a bitmap.
+extern inline void bitmap_remote_set( xptr_t    bitmap_xp,
+                                      uint32_t  index );
+
+/*********************************************************************************************
+ * These functions clear a specific bit in a local or remote bitmap.
  *********************************************************************************************
  * @ bitmap  : pointer on the bitmap
@@ -112,6 +128,24 @@
                                  uint32_t   index );
 
-/*********************************************************************************************
- * This function returns a specific bit in a bitmap.
+extern inline void bitmap_remote_clear( xptr_t     bitmap_xp, 
+                                        uint32_t   index );
+
+/*********************************************************************************************
+ * These functions search the first bit non-set in a local or remote bitmap, in the
+ * range [0 , size-1], set this bit, and return the index of the found bit.
+ * The lock protecting the bitmap must be taken by the caller.
+ *********************************************************************************************
+ * @ bitmap  : pointer on the bitmap.
+ * @ size    : number of bits to scan.
+ * @ returns index of found bit / returns 0xFFFFFFFF if not found.
+ ********************************************************************************************/
+extern uint32_t bitmap_alloc( bitmap_t * bitmap, 
+                              uint32_t   size );
+
+extern uint32_t bitmap_remote_alloc( xptr_t    bitmap_xp,
+                                     uint32_t  size );
+
+/*********************************************************************************************
+ * This function returns the index of aa specific bit in a bitmap.
  *********************************************************************************************
  * @ bitmap  : pointer on the bitmap
@@ -179,5 +213,6 @@
 
 /*********************************************************************************************
- * This function returns the index of first bit cleared in a bitmap, starting from bit 0.
+ * These functions return the index of first bit cleared in a local or remote bitmap,
+ * starting from bit 0.
  *********************************************************************************************
  * @ bitmap  : pointer on the bitmap
@@ -187,4 +222,7 @@
 extern uint32_t bitmap_ffc( bitmap_t * bitmap, 
                             uint32_t   size );
+
+extern uint32_t bitmap_remote_ffc( xptr_t   bitmap_xp, 
+                                   uint32_t size );
 
 /*********************************************************************************************
Index: /trunk/kernel/libk/elf.c
===================================================================
--- /trunk/kernel/libk/elf.c	(revision 656)
+++ /trunk/kernel/libk/elf.c	(revision 657)
@@ -224,7 +224,9 @@
 	error_t      error;
 
-    // get file name for error reporting and debug
+    // get file cluster and local pointer
     cxy_t         file_cxy = GET_CXY( file_xp );
     vfs_file_t  * file_ptr = GET_PTR( file_xp );
+
+    // get file name for error reporting and debug
     vfs_inode_t * inode    = hal_remote_lpt( XPTR( file_cxy , &file_ptr->inode ) );
     vfs_inode_get_name( XPTR( file_cxy , inode ) , name );
Index: /trunk/kernel/libk/grdxt.c
===================================================================
--- /trunk/kernel/libk/grdxt.c	(revision 656)
+++ /trunk/kernel/libk/grdxt.c	(revision 657)
@@ -332,4 +332,112 @@
 ////////////////////////////////////////////////////////////////////////////////////////
 
+////////////////////////////////////////////
+error_t grdxt_remote_init( xptr_t     rt_xp,
+                           uint32_t   ix1_width,
+                           uint32_t   ix2_width,
+                           uint32_t   ix3_width )
+{
+    void      ** root;
+	kmem_req_t   req;
+
+    // get cluster and local pointer
+    cxy_t     rt_cxy = GET_CXY( rt_xp );
+    grdxt_t * rt_ptr = GET_PTR( rt_xp );
+  
+    // initialize widths
+    hal_remote_s32( XPTR( rt_cxy , &rt_ptr->ix1_width ) , ix1_width );
+    hal_remote_s32( XPTR( rt_cxy , &rt_ptr->ix2_width ) , ix2_width );
+    hal_remote_s32( XPTR( rt_cxy , &rt_ptr->ix3_width ) , ix3_width );
+
+    // allocates first level array
+	req.type  = KMEM_KCM;
+	req.order = ix1_width + ( (sizeof(void*) == 4) ? 2 : 3 );
+	req.flags = AF_KERNEL | AF_ZERO;
+	root      = kmem_remote_alloc( rt_cxy , &req );
+
+	if( root == NULL )
+    {
+        printk("\n[ERROR] in %s : cannot allocate first level array\n", __FUNCTION__);
+        return -1;
+    }
+  
+    // register first level array in rt descriptor
+    hal_remote_spt( XPTR( rt_cxy , &rt_ptr->root ) , root );
+ 
+	return 0;
+
+}  // end grdxt_remote_init()
+
+//////////////////////////////////////////
+void grdxt_remote_destroy( xptr_t  rt_xp )
+{
+	kmem_req_t req;
+
+    uint32_t   w1;
+    uint32_t   w2;
+    uint32_t   w3;
+
+	uint32_t   ix1;
+	uint32_t   ix2;
+	uint32_t   ix3;
+
+    void    ** ptr1;
+    void    ** ptr2;
+    void    ** ptr3;
+
+    // get cluster and local pointer
+    cxy_t     rt_cxy = GET_CXY( rt_xp );
+    grdxt_t * rt_ptr = GET_PTR( rt_xp );
+
+    // get widths
+    w1 = hal_remote_l32( XPTR( rt_cxy , &rt_ptr->ix1_width ) );
+    w2 = hal_remote_l32( XPTR( rt_cxy , &rt_ptr->ix2_width ) );
+    w3 = hal_remote_l32( XPTR( rt_cxy , &rt_ptr->ix3_width ) );
+
+    // get ptr1
+    ptr1 = hal_remote_lpt( XPTR( rt_cxy , &rt_ptr->root ) );
+
+	for( ix1=0 ; ix1 < (uint32_t)(1 << w1) ; ix1++ )
+	{
+        // get ptr2
+        ptr2 = hal_remote_lpt( XPTR( rt_cxy , &ptr1[ix1] ) );
+
+		if( ptr2 == NULL ) continue;
+
+        for( ix2=0 ; ix2 < (uint32_t)(1 << w2) ; ix2++ )
+        {
+            // get ptr2
+            ptr3 = hal_remote_lpt( XPTR( rt_cxy , &ptr2[ix2] ) );
+
+		    if( ptr3 == NULL ) continue;
+
+            for( ix3=0 ; ix3 < (uint32_t)(1 << w3) ; ix3++ )
+            {
+                 if( ptr3[ix3] != NULL )
+                 {
+                     printk("\n[WARNING] in %s : ptr3[%d][%d][%d] non empty\n",
+                     __FUNCTION__, ix1, ix2, ix3 );
+                 }
+            }
+
+            // release level 3 array 
+            req.type = KMEM_KCM;
+		    req.ptr  = ptr3;
+		    kmem_remote_free( rt_cxy , &req );
+        }
+
+        // release level 2 array
+        req.type = KMEM_KCM;
+		req.ptr  = ptr2;
+	    kmem_remote_free( rt_cxy , &req );
+    }
+
+    // release level 1 array
+    req.type = KMEM_KCM;
+	req.ptr  = ptr1;
+    kmem_remote_free( rt_cxy , &req );
+
+}  // end grdxt_remote_destroy()
+
 //////////////////////////////////////////////
 error_t grdxt_remote_insert( xptr_t     rt_xp,
@@ -464,5 +572,5 @@
 
 ////////////////////////////////////////////
-void * grdxt_remote_remove( xptr_t    rt_xp,
+xptr_t grdxt_remote_remove( xptr_t    rt_xp,
                             uint32_t  key )
 {
@@ -489,9 +597,9 @@
     // get ptr2
 	void ** ptr2 = hal_remote_lpt( XPTR( rt_cxy , &ptr1[ix1] ) );
-	if( ptr2 == NULL ) return NULL;
+	if( ptr2 == NULL ) return XPTR_NULL;
 
     // get ptr3
 	void ** ptr3 = hal_remote_lpt( XPTR( rt_cxy , &ptr2[ix2] ) );
-	if( ptr3 == NULL ) return NULL;
+	if( ptr3 == NULL ) return XPTR_NULL;
 
     // get value
@@ -502,5 +610,5 @@
 	hal_fence();
 
-	return value;
+	return XPTR( rt_cxy , value );
 
 }  // end grdxt_remote_remove()
@@ -523,7 +631,7 @@
 
     // compute indexes
-    uint32_t        ix1 = key >> (w2 + w3);              // index in level 1 array
-	uint32_t        ix2 = (key >> w3) & ((1 << w2) -1);  // index in level 2 array
-	uint32_t        ix3 = key & ((1 << w3) - 1);         // index in level 3 array
+    uint32_t       ix1 = key >> (w2 + w3);              // index in level 1 array
+	uint32_t       ix2 = (key >> w3) & ((1 << w2) -1);  // index in level 2 array
+	uint32_t       ix3 = key & ((1 << w3) - 1);         // index in level 3 array
 
     // get ptr1
@@ -546,4 +654,70 @@
 
 }  // end grdxt_remote_lookup()
+
+////////////////////////////////////////////////
+xptr_t grdxt_remote_get_first( xptr_t     rt_xp,
+                               uint32_t   start_key,
+                               uint32_t * found_key )
+{
+    uint32_t        ix1;
+    uint32_t        ix2;
+    uint32_t        ix3;
+
+    void        ** ptr1;       // local base address of remote first level array
+    void        ** ptr2;       // local base address of remote second level array
+    void        ** ptr3;       // local base address of remote third level array
+
+    // get cluster and local pointer on remote rt descriptor
+    grdxt_t       * rt_ptr = GET_PTR( rt_xp );
+    cxy_t           rt_cxy = GET_CXY( rt_xp );
+
+    // get widths
+    uint32_t        w1 = hal_remote_l32( XPTR( rt_cxy , &rt_ptr->ix1_width ) );
+    uint32_t        w2 = hal_remote_l32( XPTR( rt_cxy , &rt_ptr->ix2_width ) );
+    uint32_t        w3 = hal_remote_l32( XPTR( rt_cxy , &rt_ptr->ix3_width ) );
+
+// Check key value
+assert( ((start_key >> (w1 + w2 + w3)) == 0 ), "illegal key value %x\n", start_key );
+
+    // compute min indexes
+    uint32_t       min1 = start_key >> (w2 + w3);            
+	uint32_t       min2 = (start_key >> w3) & ((1 << w2) -1);
+	uint32_t       min3 = start_key & ((1 << w3) - 1);  
+
+    // compute max indexes
+    uint32_t       max1 = 1 << w1;
+    uint32_t       max2 = 1 << w2;
+    uint32_t       max3 = 1 << w3;
+
+    // get ptr1
+    ptr1 = hal_remote_lpt( XPTR( rt_cxy , &rt_ptr->root ) );
+
+    for( ix1 = min1 ; ix1 < max1 ; ix1++ )
+    {
+        ptr2 = hal_remote_lpt( XPTR( rt_cxy , &ptr1[ix1] ) );
+        if( ptr2 == NULL ) continue;
+
+        for( ix2 = min2 ; ix2 < max2 ; ix2++ )
+        {
+            ptr3 = hal_remote_lpt( XPTR( rt_cxy , &ptr2[ix2] ) );
+            if( ptr3 == NULL ) continue;
+
+            for( ix3 = min3 ; ix3 < max3 ; ix3++ )
+            {
+                void * item = hal_remote_lpt( XPTR( rt_cxy , &ptr3[ix3] ) );
+
+                if( item == NULL ) continue;
+                else                    
+                {
+                    *found_key = (ix1 << (w2+w3)) | (ix2 << w3) | ix3;
+                    return XPTR( rt_cxy , item );
+                }
+            }
+        }
+    }
+
+    return XPTR_NULL;
+
+}  // end grdxt_remote_get_first()
 
 /////////////////////////i/////////////////
Index: /trunk/kernel/libk/grdxt.h
===================================================================
--- /trunk/kernel/libk/grdxt.h	(revision 656)
+++ /trunk/kernel/libk/grdxt.h	(revision 657)
@@ -2,5 +2,5 @@
  * grdxt.h - Three-levels Generic Radix-tree definition.
  * 
- * Authors  Alain Greiner (2016,2017,2018,2019)
+ * Authors  Alain Greiner (2016,2017,2018,2019,2019)
  *
  * Copyright  UPMC Sorbonne Universites
@@ -124,6 +124,6 @@
 /*******************************************************************************************
  * This function scan all radix-tree entries in increasing key order, starting from
- * the value defined by the <start_key> argument, and return a pointer on the first valid
- * registered item, and the found item key value.
+ * the key defined by the <start_key> argument. It returns a pointer on the first valid
+ * registered item, and returns in the <found_key> buffer the found item key value.
  * It must be called by a local thread.
  *******************************************************************************************
@@ -142,6 +142,32 @@
 
 /*******************************************************************************************
+ * This function initialises the radix-tree descriptor,
+ * and allocates memory for the first level array of pointers.
+ * It can be called by any thread running in any cluster
+ *******************************************************************************************
+ * @ rt_xp     : extended pointer on the radix-tree descriptor.
+ * @ ix1_width : number of bits in ix1 field
+ * @ ix2_width : number of bits in ix2 field
+ * @ ix3_width : number of bits in ix3 field
+ * @ returns 0 if success / returns ENOMEM if no more memory.      
+ ******************************************************************************************/
+error_t grdxt_remote_init( xptr_t     rt_xp,
+                           uint32_t   ix1_width,
+                           uint32_t   ix2_width,
+                           uint32_t   ix3_width );
+
+/*******************************************************************************************
+ * This function releases all memory allocated to the radix-tree infrastructure.
+ * A warning message is printed on the kernel TXT0 if the radix tree is not empty.
+ * It can be called by any thread running in any cluster
+ *******************************************************************************************
+ * @ rt_xp    : extended pointer on the radix-tree descriptor.
+ ******************************************************************************************/
+void grdxt_remote_destroy( xptr_t  rt_xp );
+
+/*******************************************************************************************
  * This function insert a new item in a - possibly remote - radix tree.
  * It dynamically allocates memory for new second and third level arrays if required.
+ * It can be called by any thread running in any cluster
  *******************************************************************************************
  * @ rt_xp   : extended pointer on the radix-tree descriptor.
@@ -157,10 +183,11 @@
  * This function removes an item identified by its key from a - possibly remote - radix
  * tree, and returns a local pointer on the removed item. No memory is released.
+ * It can be called by a thread running in any cluster
  *******************************************************************************************
  * @ rt_xp   : pointer on the radix-tree descriptor.
  * @ key     : key value.
- * @ returns local pointer on removed item if success / returns NULL if failure.
- ******************************************************************************************/
-void * grdxt_remote_remove( xptr_t    rt_xp,
+ * @ returns extended pointer on removed item if success / returns XPTR_NULL if failure.
+ ******************************************************************************************/
+xptr_t grdxt_remote_remove( xptr_t    rt_xp,
                             uint32_t  key );
 
@@ -169,8 +196,9 @@
  * on the item identified by the <key> argument, from the radix tree identified by
  * the <rt_xp> remote pointer.
+ * It can be called by a thread running in any cluster
  *******************************************************************************************
  * @ rt_xp   : extended pointer on the radix-tree descriptor.
  * @ key     : key value.
- * @ returns an extended pointer on found item if success / returns XPTR_NULL if failure.
+ * @ returns extended pointer on found item if success / returns XPTR_NULL if not found.
  ******************************************************************************************/
 xptr_t grdxt_remote_lookup( xptr_t     rt_xp, 
@@ -178,5 +206,22 @@
 
 /*******************************************************************************************
+ * This function scan all radix-tree entries of a - possibly remote - radix tree <rt_xp>,
+ * in increasing key order, starting from the key defined by the <start_key> argument.
+ * It returns an extended pointer on the first valid registered item, and returns in the
+ * <found_key> buffer the found item key value.
+ * It can be called by a thread running in any cluster
+ *******************************************************************************************
+ * @ rt_xp      : extended pointer on the radix-tree descriptor.
+ * @ start_key  : key starting value for the scan.
+ * @ found_key  : [out] buffer for found key value.
+ * @ return xptr on first valid item if found / return XPTR_NULL if no item found.
+ ******************************************************************************************/
+xptr_t grdxt_remote_get_first( xptr_t     rt_xp,
+                               uint32_t   start_key,
+                               uint32_t * found_key );
+
+/*******************************************************************************************
  * This function displays the current content of a possibly remote radix_tree.
+ * It can be called by a thread running in any cluster
  *******************************************************************************************
  * @ rt      : extended pointer on the radix-tree descriptor.
